#undef NDEBUG
#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <unistd.h>
#include <sys/stat.h>
#include <assert.h>
#include <string.h>


/* Xilinx */
#include "xparameters.h"
#include "xutil.h"
#include "mb_interface.h"
#include "stdio.h"

#include "puff.h"
#include "gfxlib.c"

void outbyte ( unsigned char x ) ;


extern const char boot_me_data [];
extern int boot_me_len;
typedef void (* Target_Fn) ( void ) ;

void Cache ( void )
{
    unsigned i ;

    microblaze_disable_icache () ;
    microblaze_disable_dcache () ;
    for (i = 0; i < 65536; i += 4)
    {
        asm volatile ( 
                "addik r3, %0, 0\n"
                "wic r3, r0\n"
                "nop\n"
                "addik r3, %0, 0\n"
                "wdc r3, r0\n"
                "nop\n" : : "r"(i) : "r3" ) ;
    }
    microblaze_enable_icache () ;
    microblaze_enable_dcache () ;
}

int main ( void )
{
    unsigned            offset = 10;
    unsigned long       src_len = boot_me_len - offset;
    unsigned long       dest_len = 0x03000000;
    unsigned char *     dest = (unsigned char *) 0x8c000000;
    Target_Fn           target_code = (Target_Fn) dest;
    int                 rc;

    assert ( dest != NULL ) ;
    print ( "\r\nSecond stage beginning\r\n" ) ;
    Cache () ;
    Text(1, 100, " Stage 2 boot loader", 0x20);
    Text(1, 108, " Source: ", 0x20);
    Text_Hex(1 + (9 * 8), 108, (unsigned) boot_me_data, 0x20);
    Text(1, 116, " Target: ", 0x20);
    Text_Hex(1 + (9 * 8), 116, (unsigned) dest, 0x20);

    print ( "Source " );
    printhex ( (unsigned) boot_me_data ) ;
    print ( "\r\n" ) ;
    print ( "Target " );
    printhex ( (unsigned) dest ) ;
    print ( "\r\n" ) ;
    print ( "Compressed size " );
    printhex ( src_len ) ;
    print ( "\r\n" ) ;
    rc = puff(dest, & dest_len, 
            (unsigned char *) & boot_me_data [ offset ], 
            & src_len);
    if (rc != 0) {
        Text(1, 124, " Decompression failed", 0x10);
        print ( "failed with rc " );
        printhex ( rc ) ;
        print ( "\r\n" );
        while (1) {}
        return 0 ;
    }
    Text(1, 124, " Decompression ok", 0x10);
    Text(1, 132, " D Size: ", 0x20);
    Text_Hex(1 + (9 * 8), 132, dest_len, 0x20);
    Text(1, 140, " Launch", 0x10);

    print ( "Decompressed size " );
    printhex ( dest_len ) ;
    print ( "\r\n" );
    Cache () ;

    print ( "Launch!\r\n" );
    target_code () ;
    return 0 ;
}

void __assert (const char * one, int two , const char * three)
{
    print("\r\nBang! Assertion failed\r\n");
    print( (char *) one);
    print(" ");
    printhex(two);
    print(" ");
    print( (char *) three);
    print("\r\n");
    asm volatile ( ".long 0x80000001\n" ) ;
    exit ( 1 ) ;
}




